#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"

constexpr byte Char_Remain = Char_MyFighter;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}


static ptr<byte> PrintRemain(ptr<byte> pVram)
{
    byte c;
    c = Char_Remain;
    
    repeat (2) {
        pVram = Put3(pVram, c);
        ++c;
    }
    pVram += VramRowSize3 - 2 * VramStep;
    
    repeat (2) {
        pVram = Put2(pVram, c);
        ++c;
    }
    pVram += VramRowSize2 - 2 * VramStep;
    
    return pVram + (2 * VramStep - VramRowSize5);
}


static ptr<byte> EraseRemain(ptr<byte> pVram)
{
    repeat (2) {
        pVram = Put3(pVram, Char_Space);
    }
    pVram += VramRowSize3 - 2 * VramStep;

    repeat (2) {
        pVram = Put2(pVram, Char_Space);
    }
    pVram += VramRowSize2 - 2 * VramStep;

    return pVram + (2 * VramStep - VramRowSize5);
}


void PrintStatus() 
{
    PrintS(Vram + 0, "SC");
    PrintS(Vram + 10, "HI");
    PrintS(Vram + 20, "ST");
    {
        ptr<byte> pVram;
        pVram = Vram + 26 * VramStep;
        if (RemainCount > 1) {
            byte i;
            i = RemainCount - 1;
            if (i > 2) {
                pVram = PrintRemain(pVram);
                pVram = PrintC(pVram, ' ');
                pVram = PrintC(pVram, i + '0');
            }
            else {
                do {
                    pVram = PrintRemain(pVram);
                    --i;
                } while (i != 0);
                EraseRemain(pVram);
            }
        }
        else {
            EraseRemain(pVram);           
        }
    }
    PrintStage();
    PrintScore();
    // PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + 2 * VramStep , Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + 12 * VramStep, HiScore);
    PrintC(pVram, '0');
}

void PrintStage()
{
    PrintByteNumber2(Vram + 22 * VramStep, CurrentStage + 1);
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize6 * 6 + 11, "GAME OVER");
}

void Title()
{
    static const byte[] TitleBytes = {
        //	A
        0x00, 0x0e, 0x0d, 0x02, 
        0x0c, 0x03, 0x00, 0x0f, 
        0x0c, 0x07, 0x05, 0x0f, 
        0x04, 0x01, 0x00, 0x05, 
        //	E
        0x0c, 0x07, 0x05, 0x01, 
        0x0c, 0x0b, 0x0a, 0x02, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
        //	R
        0x0c, 0x07, 0x05, 0x0b, 
        0x0c, 0x03, 0x08, 0x0f, 
        0x0c, 0x07, 0x0f, 0x02, 
        0x04, 0x01, 0x04, 0x05, 
        //	I
        0x04, 0x0d, 0x07, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x0c, 0x03, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
        //	A
        0x00, 0x0e, 0x0d, 0x02, 
        0x0c, 0x03, 0x00, 0x0f, 
        0x0c, 0x07, 0x05, 0x0f, 
        0x04, 0x01, 0x00, 0x05, 
        //	L
        0x0c, 0x03, 0x00, 0x00, 
        0x0c, 0x03, 0x00, 0x00, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
    };

    ClearScreen(); 
    HideAllSprites();
    PrintStatus();
    {
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize6 * 3 + (32 - 4 * 6) / 2;
        p = TitleBytes;
        repeat (6) {
            repeat (2) {
                repeat (4) {
                    pVram = Put3(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize3 - 4;

                repeat (4) {
                    pVram = Put2(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize2 - 4;
            }
            pVram += 4 - VramRowSize5 * 2;
        }
    }
    PrintS(Vram + VramWidth * 44 + 9, "PUSH SPACE KEY");
    PrintS(Vram + VramWidth * 50 + 9, "OR SHIFT KEY");
    PrintS(Vram + VramWidth * 58 + VramWidth - 12, "INUFUTO 2022");
    // {
    //     byte c;
    //     ptr<byte> v;
    //     v = Vram+32*10;
    //     c = 0;
    //     repeat (0) {
    //         v = Put3(v, c);
    //         ++c;
    //     }
    // }
}
